from sqlalchemy import *
from migrate import *
import migrate.changeset

class Dictionaries(object):
    def __init__(self, meta):
        self.hotkey=Table('hotkey',meta,
            Column('hotkeycode', Integer, nullable=False, primary_key=True, autoincrement=True),
            Column('hotkeyname', String(100)),
        )
        self.hotkeyinvent=Table('hotkeyinvent',meta,
            Column('hotkeyinventid', Integer, nullable=False, primary_key=True, autoincrement=True),
            Column('inventcode', String(100)),
            Column('hotkeycode', Integer, nullable=False),
        )

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    dictionaries = Dictionaries(meta)
    for table in filter(lambda x: isinstance(x,Table), map(lambda x: getattr(dictionaries,x), dir(dictionaries))):
        basename = table.name
        for suffix in ['1','2']:
            table.name = basename+suffix
            table.create()
    conn = migrate_engine.connect()
    
    for table in filter(lambda x: isinstance(x, Table), map(lambda x: getattr(dictionaries, x), dir(dictionaries))):
        basename = table.name[:-1]
        conn.execute('create view %s as select * from %s' % (basename, basename + '1'))

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    dictionaries = Dictionaries(meta)
    for table in filter(lambda x: isinstance(x,Table), map(lambda x: getattr(dictionaries,x), dir(dictionaries))):
        basename = table.name
        for suffix in ['1','2']:
            table.name = basename+suffix
            table.drop()
    conn = migrate_engine.connect()
    for table in filter(lambda x: isinstance(x, Table), map(lambda x: getattr(dictionaries, x), dir(dictionaries))):
        basename = table.name[:-1]
        conn.execute('drop view %s' % (basename))

