from sqlalchemy import *
from migrate import *
import migrate.changeset
from dictionaries.versions import views_helper
import re

def getCardTables(meta):
    card1 = Table('card1', meta, autoload=True)
    card2 = Table('card2', meta, autoload=True)
    return [card1, card2]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    for tbl in getCardTables(meta):
        lastknownbonusbalance = Column('lastknownbonusbalance', Numeric(15, 2), nullable=True)
        if not 'lastknownbonusbalance' in tbl.columns: 
            lastknownbonusbalance.create(tbl)
        lastknownbonusbalancedate = Column('lastknownbonusbalancedate', DateTime, nullable=True)
        if not 'lastknownbonusbalancedate' in tbl.columns: 
            lastknownbonusbalancedate.create(tbl)
        multiplicator = Column('multiplicator', Numeric(15, 2), nullable=True)
        if not 'multiplicator' in tbl.columns: 
            multiplicator.create(tbl)
        multiplicatorbeg = Column('multiplicatorbeg', DateTime, nullable=True)
        if not 'multiplicatorbeg' in tbl.columns: 
            multiplicatorbeg.create(tbl)
        multiplicatorend = Column('multiplicatorend', DateTime, nullable=True)
        if not 'multiplicatorend' in tbl.columns: 
            multiplicatorend.create(tbl)
        multiplicatorcurrent = Column('multiplicatorcurrent', Numeric(15, 2), nullable=True)
        if not 'multiplicatorcurrent' in tbl.columns: 
            multiplicatorcurrent.create(tbl)
    views_helper.update_dic_view(migrate_engine, 'card')


def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Operations to reverse the above upgrade go here.
    conn = migrate_engine.connect()
    tblname = views_helper.get_table_name(migrate_engine,'card')
    for tbl in getCardTables(meta):
        if 'lastknownbonusbalance' in tbl.columns:
            tbl.c.lastknownbonusbalance.drop()
        if 'lastknownbonusbalancedate' in tbl.columns:
            tbl.c.lastknownbonusbalancedate.drop()
        if 'multiplicator' in tbl.columns:
            tbl.c.multiplicator.drop()
        if 'multiplicatorbeg' in tbl.columns:
            tbl.c.multiplicatorbeg.drop()
        if 'multiplicatorend' in tbl.columns:
            tbl.c.multiplicatorend.drop()
        if 'multiplicatorcurrent' in tbl.columns:
            tbl.c.multiplicatorcurrent.drop()
    views_helper.update_dic_view(migrate_engine, 'card',tblname)
