from sqlalchemy import *
from migrate import *
import migrate.changeset
from dictionaries.versions import views_helper

def getGoodsTableMemory(meta):
    goodsTableMemory = Table('tmpshortgoodslist', meta,
        Column('code', String(100), primary_key=True),
        Column('quantity', Numeric(precision = 15, scale = 3)),
        mysql_engine = 'Memory',
        mysql_charset = 'utf8',
        extend_existing = True
    )
    return goodsTableMemory

def getKitTable(meta):
    kit1 = Table('kit1', meta, autoload=True)
    kit2 = Table('kit2', meta, autoload=True)
    return [kit1, kit2]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    for tbl in getKitTable(meta):
        kittype = Column('kittype', Integer, default = '0')       
        if not kittype.name in tbl.columns:       
            kittype.create(tbl)        
    
    goodsTableMemory = getGoodsTableMemory(meta)
    if goodsTableMemory.exists(meta.bind):
        goodsTableMemory.drop()
        
    goodsTableMemory.create()
    views_helper.update_dic_view(migrate_engine, 'kit')

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    tblname = views_helper.get_table_name(migrate_engine,'kit')
    for tbl in getKitTable(meta):
        if 'kittype' in tbl.columns:
            tbl.c.kittype.drop()
            
    goodsTableMemory = getGoodsTableMemory(meta)
    if goodsTableMemory.exists(meta.bind):
        goodsTableMemory.drop()
    views_helper.update_dic_view(migrate_engine, 'kit',tblname)