from sqlalchemy import *
from migrate import *
import migrate.changeset

class Dictionaries(object):
    def __init__(self, meta):
        self.tmcrequiredquantity=Table('tmcrequiredquantity', meta,
            Column('tmccode', String(30), nullable = False, primary_key = True),
        )
        self.tmcvisualverify=Table('tmcvisualverify', meta,
            Column('tmccode', String(30), nullable = False, primary_key = True),
        )

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    dictionaries = Dictionaries(meta)
    for table in filter(lambda x: isinstance(x,Table), map(lambda x: getattr(dictionaries,x), dir(dictionaries))):
        basename = table.name
        for suffix in ['1','2']:
            table.name = basename+suffix
            if not table.exists():
                table.create()
    conn = migrate_engine.connect()
    for table in filter(lambda x: isinstance(x, Table), map(lambda x: getattr(dictionaries, x), dir(dictionaries))):
        basename = table.name[:-1]
        conn.execute('create or replace view %s as select * from %s' % (basename, basename + '1'))

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    dictionaries = Dictionaries(meta)
    for table in filter(lambda x: isinstance(x,Table), map(lambda x: getattr(dictionaries,x), dir(dictionaries))):
        basename = table.name
        for suffix in ['1','2']:
            table.name = basename+suffix
            if table.exists():
                table.drop()
    conn = migrate_engine.connect()
    for table in filter(lambda x: isinstance(x, Table), map(lambda x: getattr(dictionaries, x), dir(dictionaries))):
        basename = table.name[:-1]
        conn.execute('drop view if exists %s' % (basename))
