from sqlalchemy import *
from migrate import *
import migrate.changeset

def getTables(meta):
    aspectitem = Table('aspectitem', meta, autoload=True)
    bonusitem = Table('bonusitem', meta, autoload=True)
    button = Table('button', meta, autoload=True)
    carditem = Table('carditem', meta, autoload=True)
    client = Table('client', meta, autoload=True)
    crights = Table('crights', meta, autoload=True)
    department = Table('department', meta, autoload=True)
    discitem = Table('discitem', meta, autoload=True)
    document = Table('document', meta, autoload=True)
    goodsitem = Table('goodsitem', meta, autoload=True)
    moneyitem = Table('moneyitem', meta, autoload=True)
    paymentitem = Table('paymentitem', meta, autoload=True)
    stornogoodsitem = Table('stornogoodsitem', meta, autoload=True)
    
    groups = [ aspectitem, bonusitem, button, carditem, client, crights, department, discitem, document, goodsitem, moneyitem, paymentitem, stornogoodsitem ]
    return groups

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.    

    for group in getTables(meta):
        col = Column('cashcode', String(30), nullable=True)
        col.create(group)

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Operations to reverse the above upgrade go here.

    for group in getTables(meta):
        group.c.cashcode.drop()
