from sqlalchemy import *
from migrate import *
from documents.versions import dump

def getTable(meta):
    return Table('moneyitem', meta, autoload=True)

def getColumns():
    return [Column('valutoperation', Integer, nullable = True),
            Column('valname', String(100), nullable = True),
            Column('balance', Numeric(precision=13, scale=2), nullable = True)]

def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; bind migrate_engine
    # to your metadata
    meta = MetaData(bind = migrate_engine)
    dump.store(migrate_engine)
    for column in getColumns():
        if column.name not in getTable(meta).columns:
            column.create(getTable(meta))

def downgrade(migrate_engine):
    # Operations to reverse the above upgrade go here.
    meta = MetaData(bind = migrate_engine)
    for column in getColumns():
        if column.name in getTable(meta).columns:
            getTable(meta).c[column.name].drop()
