from sqlalchemy import *
from migrate import *

tableName = 'couponitem'

def getTable(meta):
    return Table(tableName, meta, autoload=True)

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)

    tbl = getTable(meta)

    if 'campaignid' not in tbl.columns:
        Column('campaignid', Integer, nullable=True).create(tbl)

    if 'campaignname' not in tbl.columns:
        Column('campaignname', String(100), nullable=True).create(tbl)

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    tbl = getTable(meta)

    if 'campaignid' in tbl.columns:
        Column('campaignid', Integer, nullable=True).drop(tbl)

    if 'campaignname' in tbl.columns:
        Column('campaignname', String(100), nullable=True).drop(tbl)
