from sqlalchemy import *
from migrate import *
import migrate.changeset

def getDocument(meta):
    return Table('document', meta, autoload=True)

def getCashItem(meta):
    return Table('cashitem', meta,
        Column('cashitemid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('documentid', Integer, ForeignKey(getDocument(meta).c.documentid, name='cashitemdocumentidfk', ondelete='CASCADE'), nullable=False),
        Column('denomination', Integer, nullable=False),
        Column('count', Integer, nullable=False),
        Column('isaccessible', Integer, nullable=False),
        Column('isout', Integer, nullable=False),
        Column('devtype', Integer, nullable=False),
        mysql_engine='InnoDB'
    )

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    table = getCashItem(meta)
    if not table.exists(meta.bind):
        table.create()

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    table = getCashItem(meta)
    if table.exists(meta.bind):
        table.drop()
