from sqlalchemy import *
from migrate import *
from documents.versions import dump

columnName = 'minretailprice'
columnType = Numeric(precision=13, scale=2)

def getTables(meta):
    goodsitem = Table('goodsitem', meta, autoload = True)
    stornogoodsitem = Table('stornogoodsitem', meta, autoload = True)
    return [goodsitem, stornogoodsitem]


def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    dump.store(migrate_engine)

    for table in getTables(meta):
        if not columnName in table.columns:
            Column(columnName, columnType, nullable=True).create(table)
        else:
            table.c.minretailprice.alter(nullable=True)

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)

    for table in getTables(meta):
        if columnName in table.columns:
            Column(columnName, columnType, nullable=True).drop(table)
