from sqlalchemy import *
from migrate import *

def getDocumentTable(meta):
    return Table('document', meta, autoload=True)

def getFailedMoneyItemTable(meta):
    return Table('failedmoneyitem', meta,
        Column('failedmoneyitemid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('documentid', Integer, ForeignKey(getDocumentTable(meta).c.documentid, name='failedmoneyitemdocumentidfk', ondelete='CASCADE'), nullable=False),
        Column('scode', String(30), nullable=False),
        Column('mtime', DateTime, nullable=False),
        Column('opcode', Integer, nullable=False),
        Column('valcode', Integer, nullable=False),
        Column('sumb', Numeric(precision=13, scale=2), nullable=False),
        Column('docnum', String(32), nullable=True),
        Column('frnum', Integer, nullable=False),
        Column('cardnum', String(100), nullable=False),
        Column('cashcode', String(30), nullable=True),
        Column('slip', Text, nullable=True),
        Column('valutoperation', Integer, nullable=True),
        Column('valname', String(100), nullable=True),
        Column('merchantid', String(255), nullable=True),
        mysql_engine='InnoDB'
    )

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    failedMoneyItemTable = getFailedMoneyItemTable(meta)
    if not failedMoneyItemTable.exists(meta.bind):
        failedMoneyItemTable.create()

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    failedMoneyItemTable = getFailedMoneyItemTable(meta)
    if failedMoneyItemTable.exists(meta.bind):
        failedMoneyItemTable.drop()
